<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      custom-class="modal-large"
      :title="newStatus ? 'Добавление типа груза' : 'Просмотр типа груза'"
      :is-show-controls="false"
      :is-show-pagination="!newStatus"
    >
      <cargo-type
        :data-source="selectedData"
        :api="api"
        @submit="preparedSave"
        @delete="onDelete"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api                     from '@/api';
import itemMixin               from '@/mixins/dictionaries/edit-item';
import paging                  from '@/mixins/dictionaries/paging';
import SinglePane              from 'common-components/src/obComponents/obSinglePanels';
import CargoType               from './modal/CargoType';
import ObModal                 from 'common-components/src/obComponents/obModal';
import ObTable                 from 'common-components/src/obComponents/obTable';
import { TEMPERATURE_MODE_ICONS } from '@/resources/enum'
import { dictionary }          from '@/translations/ru/dictionaries__cargo__cargo_types';


export default {
  name: 'CargoTypes',
  components: {
    ObModal,
    CargoType,
    SinglePane,
    ObTable
  },
  mixins: [
    paging,
    itemMixin
  ],
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name'
        },
        {
          title: this.dictionaryRu.columns.conversion_scheme,
          key: 'conversion_scheme',
          html: function(data) {
            if (data.conversion_scheme) {
              let conversionScheme = data.conversion_scheme.reduce(
                (previous, item) => {
                  return (
                    previous +
                    item.amount +
                    ' ' +
                    (item.forwarding_unit && item.forwarding_unit.name) +
                    ' / '
                  );
                },
                ''
              );
              conversionScheme +=
                data.weight +
                ' ' +
                'т' +
                ' / ' +
                data.volume +
                ' ' +
                'м' +
                ' <sup>3</sup>';
              if (conversionScheme.length > 2) {
                conversionScheme = conversionScheme.slice(
                  0,
                  conversionScheme.length - 2
                );
              }
              return conversionScheme;
            }
            return '';
          }
        },
        {
          title: this.dictionaryRu.columns.temperature_mode,
          key: 'temperature_mode',
          width: 65,
          alignment: 'center',
          html: data => {
            let mode = '<span class="inactive">-</span>';
            if (data.temperature_mode) {
              let _icon = TEMPERATURE_MODE_ICONS[data.temperature_mode];
              mode =
                '<i style="font-size: 16px" class="-cobalt icon ' +
                _icon +
                '"></i>';
            }
            return mode;
          }
        },
        {
          title: this.dictionaryRu.columns.key_words,
          key: 'key_words',
          allowSorting: false,
          html: function(data) {
            if (data.key_words) {
              let keyWords = data.key_words.reduce((previous, item) => {
                return previous + item + ', ';
              }, '');
              if (keyWords.length > 2) {
                keyWords = keyWords.slice(0, keyWords.length - 2);
              }
              return keyWords;
            }
            return '';
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          html: data => data.is_active ? 'Активен' : 'Неактивен'
        }
      ];
    }
  },
  watch: {
    'selectedData.key_words'() {
      if (!this.selectedData.key_words) {
        this.selectedData.key_words = [];
      }
    },
    'selectedData.conversion_scheme'() {
      if (!this.selectedData.conversion_scheme) {
        this.selectedData.conversion_scheme = [
          {
            amount: '',
            forwarding_unit: {
              uuid: ''
            }
          },
          {
            amount: '',
            forwarding_unit: {
              uuid: ''
            }
          }
        ];
      }
    }
  },
  data() {
    return {
      dictionaryRu: dictionary,
      dataGridRefName: 'CargoTypes',
      api: {
        source: '/oboz2-dictionary-cargo-types-crud/v1/'
      }
    };
  },
  methods: {
    async onDelete () {
      const notificationId = `${new Date().getTime()}remove`;
      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Удаление',
          id: notificationId
        });
        await api.cargo.deleteCargoType(this.selectedData.uuid);
        this.$refs.viewItem.close();
        this.$notification({
          type: 'system_notification_success',
          message: 'Удалено'
        });
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалено'
        });
      } finally {
        this.$notification({
          event: 'close',
          id: notificationId
        });
      }
    },
    preparedSave(payload) {
      this.onSave(payload);
    }
  }
};
</script>
